//
//  Player.hpp
//  papTermOneCourseWork
//
//  Created by Charles Ringer on 28/10/2015.
//
//

#ifndef Player_hpp
#define Player_hpp
#include "ofMain.h"
#include "Wall.hpp"
#include "Endpoint.hpp"
#include "Enemy.hpp"
#include "ImageBank.hpp"
#include <stdio.h>
#include <algorithm>

class Player
{
    
private:
    //Coords
    float X;
    float Y;
    int height;
    int width;
    //Speed
    float speed;
    //The current bottom half of the sprite
    int currentBottom = 0;
    bool torchOn, up, down, left, right, goingUp, goingDown, goingLeft, goingRight = false;
    vector<ofImage*> walkingBot;
    ofImage *standingBot, *top, *torchTop;
    int prevRot = 0;
    
    
public:
    // Constuctor
    Player(vector<Wall> &walls, ImageBank &imgBank);
    
    //Getters
    int getX() { return X;};
    int getY() { return Y;};
    int getWidth() { return width;};
    int getHeight() { return height;};
    int getCenterX() {return X+10;};
    int getCenterY() {return Y+10;};
    bool getTorchOn() {return torchOn;}
    
    //Displays the player
    void disp();
    
    //Move funcs (with respect to the walls)
    void move(vector<Wall> &walls);
    bool canMove(char dir, vector<Wall> &walls);
    
    //Handles key input
    void handleKeyOn(int keyIn);
    void handleKeyOff(int keyIn);
    
    //Checks if the user has reached an end point or enemy
    int checkGameEnd(vector<Enemy> enemies, Endpoint *endPoint);
};


#endif /* Player_hpp */
